SystemOrganization addCategory: #PullUpToSuperclass!

TestCase subclass: #PullUpToSuperclassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:38'!
setUp
	super setUp.
	PullUpToSuperclass installSubjectPackage.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:38'!
tearDown
	PullUpToSuperclass uninstallSubjectPackage.
	Smalltalk garbageCollect.
	super tearDown.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:53'!
testWooluspos1
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos).
	self assert: (Smalltalk classNamed: #Wooluspos) instVarNames equals: #('c').
	self assert: (Smalltalk classNamed: #WoolClass1) instVarNames equals: #('a' 'b').
	self assert: (Smalltalk classNamed: #WoolClass2) instVarNames equals: #('b' 'd').
	self assert: (Smalltalk classNamed: #WoolClass3) instVarNames equals: #('a' 'd').
	
	self assert: (Smalltalk classNamed: #Wooluspos) selectors equals: #(#iShouldBeCategorizedTo1 #c #superClassDefinesThisDifferently #iShouldBeCategorizedTo2 #c:).
	self assert: (Smalltalk classNamed: #WoolClass1) selectors equals:  #(#a: #sourceCodeIsNotExactlySame #b #b: #superSends #superClassDefinesThisDifferently #a #referingToClassVarKeke).
	self assert: (Smalltalk classNamed: #WoolClass2) selectors equals:  #(#sourceCodeIsNotExactlySame #d #b #b: #superSends #superClassDefinesThisDifferently #d: #referingToClassVarKeke).
	self assert: (Smalltalk classNamed: #WoolClass3) selectors equals:  #(#a: #sourceCodeIsNotExactlySame #d #superSends #superClassDefinesThisDifferently #a #d: #referingToClassVarKeke).
	
	self assert: (((Smalltalk classNamed: #Wooluspos) compiledMethodAt: #iShouldBeCategorizedTo1) category) equals: #category1.
	self assert: (((Smalltalk classNamed: #Wooluspos) compiledMethodAt: #iShouldBeCategorizedTo2) category) equals: #category2.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:56'!
testWooluspos2
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos2).
	self assert: (Smalltalk classNamed: #WoolOnlyOneSubclass) instVarNames equals: #('var1').
	self assert: ((Smalltalk classNamed: #WoolOnlyOneSubclass) selectors) equals: #(#method1).
	
	self assert: (Smalltalk classNamed: #Wooluspos2) instVarNames equals: #().
	self assert: ((Smalltalk classNamed: #Wooluspos2) selectors) equals: #().! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:57'!
testWooluspos3
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos3).
	self assert: (Smalltalk classNamed: #Wooluspos3) instVarNames equals: #().
	self assert: ((Smalltalk classNamed: #Wooluspos3) selectors) equals: #().
! !

Object subclass: #PullUpToSuperclass
	instanceVariableNames: 'classes commonSuperclass commonSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclass commentStamp: 'HwaJong 5/3/2013 21:44' prior: 0!
m := PullUpToSuperclass new.
m commonSuperclass: Wooluspos.
m run.!

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 5/5/2013 10:19'!
installSubjectPackage

	self subjectPackageChunk readStream fileInAnnouncing: 'WhoolaWhoolaWooWoo'! !

!PullUpToSuperclass class methodsFor: 'public' stamp: 'HwaJong 8/3/2013 00:47'!
runAfterCreatingSuperclassNamed: aSymbol forClasses: aCollection

	| supers newClass |
	supers := (aCollection collect: #superclass) asSet.
	[supers size = 1] assert.
	newClass := (supers anyOne) subclass: aSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: (aCollection anyOne category).
	
	aCollection do: [:each| each moveToSuperclassNamed: aSymbol ].
	
	self new
		commonSuperclass: newClass;
		run.! !

!PullUpToSuperclass class methodsFor: 'public' stamp: 'HwaJong 8/3/2013 00:41'!
runOnCommonSuperclass: aClass
	
	self new
		commonSuperclass: aClass;
		run.! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 5/5/2013 16:34'!
runOnSubjectPackage 
	self new commonSuperclass: (Smalltalk classNamed: 'Wooluspos'); run.
	self new commonSuperclass: (Smalltalk classNamed: 'Wooluspos2'); run.! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 8/3/2013 13:48'!
subjectPackageChunk
	"get it from following line:

		Clipboard clipboardText asString"
^ 'Trait named: #WoolTrait
	uses: {}
	category: ''WhoolaWhoolaWooWoo''!!

!!WoolTrait methodsFor: ''as yet unclassified'' stamp: ''HwaJong 8/3/2013 10:36''!!
traitMethod1
	^''t1''!! !!

!!WoolTrait methodsFor: ''as yet unclassified'' stamp: ''HwaJong 8/3/2013 10:36''!!
traitMethod2
	^''t2''!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTrait classTrait
	uses: {}!!


Object subclass: #Wooluspos2
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!


Wooluspos2 subclass: #WoolOnlyOneSubclass
	instanceVariableNames: ''var1''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

!!WoolOnlyOneSubclass methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 16:33''!!
method1
	^self!! !!


Object subclass: #Wooluspos3
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!


Wooluspos3 subclass: #WoolTraitUser1
	uses: WoolTrait
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTraitUser1 class
	uses: WoolTrait classTrait
	instanceVariableNames: ''''!!


Wooluspos3 subclass: #WoolTraitUser2
	uses: WoolTrait
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTraitUser2 class
	uses: WoolTrait classTrait
	instanceVariableNames: ''''!!


Object subclass: #Wooluspos
	instanceVariableNames: ''c''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

!!Wooluspos methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''superclass is super''!! !!


!!Wooluspos methodsFor: ''category1'' stamp: ''HwaJong 8/3/2013 12:16''!!
iShouldBeCategorizedTo1
	^self!! !!


!!Wooluspos methodsFor: ''category2'' stamp: ''HwaJong 8/3/2013 12:16''!!
iShouldBeCategorizedTo2
	^self!! !!


!!Wooluspos methodsFor: ''accessing'' stamp: ''HwaJong 8/3/2013 12:16''!!
c
	^ c!! !!

!!Wooluspos methodsFor: ''accessing'' stamp: ''HwaJong 8/3/2013 12:16''!!
c: anObject
	c := anObject!! !!


Wooluspos subclass: #WoolClass1
	instanceVariableNames: ''a b''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
a
	^ a!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
a: anObject
	a := anObject!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
b
	^ b!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
b: anObject
	b := anObject!! !!


!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:30''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''hello''!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!


Wooluspos subclass: #WoolClass3
	instanceVariableNames: ''a d''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
a
	^ a!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
a: anObject
	a := anObject!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d
	^ d!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d: anObject
	d := anObject!! !!


!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:29''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''hello''!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!


Wooluspos subclass: #WoolClass2
	instanceVariableNames: ''b d''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo''!!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
b
	^ b!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
b: anObject
	b := anObject!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d
	^ d!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d: anObject
	d := anObject!! !!


!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:28''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''bye''!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!
'! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 5/4/2013 02:03'!
uninstallSubjectPackage

	SystemOrganization removeSystemCategory: 'WhoolaWhoolaWooWoo'! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/5/2013 15:52'!
commitMoveCommonMethods

	commonSelectors do: [:sel| 
		|code cats|
		cats := (classes collect: [:cls| (cls compiledMethodAt: sel) category ]) copyWithoutAll: { #'as yet unclassified'}.
		code := classes anyOne sourceCodeAt: sel.
		commonSuperclass compile: code classified: (cats isEmpty ifTrue: [ #'as yet unclassified'] ifFalse: [cats asBag sortedCounts first value]).
		classes do: [:cls| cls removeSelector: sel]].! !

!PullUpToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 21:43'!
commonSuperclass: aClass
	commonSuperclass := aClass! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/4/2013 00:50'!
getClasses
	classes := commonSuperclass subclasses.! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 8/3/2013 12:07'!
getCommonSelectors

	self precollectCommonSelectors.
	self rejectTraitMethods.
	self selectSelectorsSourceCodeOfAllSubclassesAreSame.
	self rejectSelectorsIfSourceCodeOfSuperclassAndSubclassIsDifferent.! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/3/2013 20:25'!
moveInstanceVariables

	|commonInstanceVariables|
	commonInstanceVariables := classes inject: classes anyOne instVarNames into: [:ivs :clss| ivs intersection: clss instVarNames].
	
	commonInstanceVariables do: [:iVarName| 
		(RBPullUpInstanceVariableRefactoring
			model: (RBNamespace onEnvironment: RBBrowserEnvironment new) variable: iVarName class: commonSuperclass) execute].

! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/5/2013 10:12'!
moveMethods

	self getCommonSelectors.
	self commitMoveCommonMethods.! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/5/2013 16:24'!
precollectCommonSelectors

	|pullUpableSelectors|
	pullUpableSelectors := classes collect: [:each| 
		((each methods reject: [:m| m sendsToSuper or: [m pragmas notEmpty] ]) collect: #selector) copyWithoutAll: (Array streamContents: [:stream| each classVarNames do: [:cvn| stream nextPutAll: (each whichSelectorsReferTo: (each bindingOf: cvn))]]) ].
	commonSelectors := pullUpableSelectors inject: (pullUpableSelectors anyOne) into: [:cs :selector| cs intersection: selector].! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/5/2013 16:22'!
rejectSelectorsIfSourceCodeOfSuperclassAndSubclassIsDifferent
	commonSelectors := commonSelectors reject: [:sel| 
		(commonSuperclass selectors includes: sel) and: [ (commonSuperclass sourceCodeAt: sel) ~= (classes anyOne sourceCodeAt: sel) ]]! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 8/3/2013 12:14'!
rejectTraitMethods
	commonSelectors := commonSelectors select: [:sel| 
		classes allSatisfy: [:cls| cls includesLocalSelector: sel ] ]! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/4/2013 00:50'!
removeEmptyCategoriesForClasses
	classes do: [:each| each organization removeEmptyCategories ].! !

!PullUpToSuperclass methodsFor: 'main operation' stamp: 'HwaJong 5/5/2013 16:27'!
run
	self getClasses.
	classes size > 1
		ifTrue: 
			[self moveInstanceVariables.
			self moveMethods.
			self removeEmptyCategoriesForClasses].! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/5/2013 16:21'!
selectSelectorsSourceCodeOfAllSubclassesAreSame

	commonSelectors := commonSelectors select: [:sel| (classes collect: [:cls| cls sourceCodeAt: sel]) asSet size = 1 ].! !
